//    weircdservices module
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void privmsg_nickserv(const char* user, const char* msg) {
	char response[513];
	char* cmd = alloca(strlen(msg)+1);
	char* params = alloca(strlen(msg)+1);
	strcpy(cmd,msg);trimleft(cmd);
	if (charpos(cmd,' ') > 0) {
		strcpy(params,cmd);
		cut(params,charpos(params,' ')+1);trimleft(params);trimright(params);
		cmd[charpos(cmd,' ')] = 0;
	}else{
		strcpy(params,"");
	}
	if (strlen(cmd) <= 0) {return;}
	if (strcasecmp(cmd,"help") == 0) {
		trimleft(params);
		cutonfirstspace(params);
		if (strcasecmp(params,"") == 0) {
			msguser(nickserv,user,"\002- NickServ help -\002");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"  You can use NickServ to register a nick,");
			msguser(nickserv,user,"   this prevents others from using it and makes");
			msguser(nickserv,user,"   sure that only you can use it and others never");
			msguser(nickserv,user,"   have to bother if it's you or someone else");
			msguser(nickserv,user,"   abusing your nick to pretend to be you.");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"  Type \002/msg NickServ help commands\002 to get a list");
			msguser(nickserv,user,"   of all available commands.");
			msguser(nickserv,user,"  Type \002/msg NickServ help register\002 to get some");
			msguser(nickserv,user,"   information on how to register your nickname");
			msguser(nickserv,user,"   to protect from others.");
			msguser(nickserv,user,"  If this doesn't help you and you still have");
			snprintf(response,499,"   trouble using NickServ, use \002/join %s\002",weircd_GetHelpChan());
			response[499] = 0;
			msguser(nickserv,user,response);
			msguser(nickserv,user,"   to enter the help channel.");
			return;
		}
		if (strcasecmp(params,"commands") == 0) {
			msguser(nickserv,user,"\002- NickServ help - \"Commands\" -\002");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"  Here is a list of all available nickserv commands");
			msguser(nickserv,user,"   (type \002/msg NickServ help <command>\002 to get");
			msguser(nickserv,user,"    more information on one of those commands):");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"    HELP");
			msguser(nickserv,user,"    IDENTIFY");
			msguser(nickserv,user,"    INFO");
			msguser(nickserv,user,"    LOGOUT");
			msguser(nickserv,user,"    CHANGEPASS");
			msguser(nickserv,user,"    REGISTER");
			msguser(nickserv,user,"    UNREGISTER");
			if (weircd_user_IsServicesOp(user) == 0) {
				msguser(nickserv,user,"\002IRCop commands:\002 DROP, STATS, SETPASS");
			}
			return;
		}
		if (strcasecmp(params,"changepass") == 0) {
			msguser(nickserv,user,"\002- NickServ help - \"ChangePass\" -\002");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"  If you are logged in to a user account, this command");
			msguser(nickserv,user,"   allows you to change your nickserv password.");
			msguser(nickserv,user,"  Usage: \002/msg NickServ changepass <old password> <new password>\002");
			return;
		}
		if (strcasecmp(params,"logout") == 0) {
			msguser(nickserv,user,"\002- NickServ help - \"Logout\" -\002");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"  If you are logged in to a user account, this command");
			msguser(nickserv,user,"   will perform a logout so you can login to another");
			msguser(nickserv,user,"   account without disconnecting.");
			msguser(nickserv,user,"  You can use the command by typing");
			msguser(nickserv,user,"   \002/msg NickServ logout\002!");
			return;
		}
		if (strcasecmp(params,"info") == 0) {
			msguser(nickserv,user,"\002- NickServ help - \"Info\" -\002");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"  Use \002/msg NickServ info <nickname>\002 to get");
			msguser(nickserv,user,"   information on a specific nickname. This can serve");
			msguser(nickserv,user,"   you to find out if a specific nickname is already");
			msguser(nickserv,user,"   registered.");
			return;
		}
		if (strcasecmp(params,"identify") == 0) {
			msguser(nickserv,user,"\002- NickServ help - \"Identify\" -\002");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"  If you signed up using nickserv,");
			msguser(nickserv,user,"   \002/msg NickServ identify <password>\002 allows you");
			msguser(nickserv,user,"   to login in case you are currently using the");
			msguser(nickserv,user,"   nickname used on signed up again.");
			msguser(nickserv,user,"   registered.");
			return;
		}
		if (strcasecmp(params,"register") == 0) {
			msguser(nickserv,user,"\002- NickServ help - \"Register\" -\002");
			msguser(nickserv,user,"-");
			msguser(nickserv,user,"  You can register your current nickname using");
			msguser(nickserv,user,"   the command \002/msg NickServ register <password> <e-mail>\002!");
			msguser(nickserv,user,"   (Please replace \002<password>\002 and \002<e-mail>\002 with proper");
			msguser(nickserv,user,"    values!)");
			msguser(nickserv,user,"-");
			if (forcerenameseconds > 0) {
				msguser(nickserv,user,"  This will protect this nick and everyone who takes");
				snprintf(response,499,"   your nickname and doesn't identify in %d seconds",forcerenameseconds);
				response[499] = 0;
				msguser(nickserv,user,response);
				msguser(nickserv,user,"   will get force-renamed so nobody can fake your");
				msguser(nickserv,user,"   identity.");
			}else{
				msguser(nickserv,user,"  This will show others in your whois when you are");
				msguser(nickserv,user,"   logged in that you are actually the user they");
				msguser(nickserv,user,"   think you are and not somebody faking you.");
			}
			msguser(nickserv,user,"  If you ever forget your secret password yourself,");
			snprintf(response,499,"   go to %s and ask for a new password being sent to",weircd_GetHelpChan());
			response[499] = 0;
			msguser(nickserv,user,response);
			msguser(nickserv,user,"   the e-mail address you entered.");
			msguser(nickserv,user,"  Only server admins will be able to see the e-mail");
			msguser(nickserv,user,"   address you entered.");
			return;
		}
		snprintf(&response[0],499,"No help available for %s",params);
		response[499] = 0;
		msguser(nickserv,user,response);
		return;
	}
	if (strcasecmp(cmd,"info") == 0) {
		trimleft(params);cutonfirstspace(params);
		if (strlen(params) <= 0) {
			msguser(nickserv,user,"Type \002/msg NickServ info <nickname>\002 to get information about a specific nickname.");
			return;
		}
		if (services_userregistered(params) == 0) {
			snprintf(response,499,"Username \"%s\" is \002registered\002.",params);
			response[499] = 0;
			msguser(nickserv,user,response);
			const char* accname = weircd_user_GetLoginAccountName(user);
			int extendedinfo = 0;
			if (accname != NULL) {
				if (strcasecmp(accname,params) == 0) {extendedinfo = 1;}
			}
			if (weircd_user_IsServicesOp(user) == 0 || extendedinfo == 1) {
				char* j = NULL;
				j = services_getemail(params);
				if (j != NULL) {
					snprintf(response,499,"The \002e-mail\002 address of \"%s\" is %s.",params,j);
					response[499] = 0;
					msguser(nickserv,user,response);
					free(j);
				}else{
					snprintf(response,499,"The \002e-mail\002 address of \"%s\" is not set.",params);
					response[499] = 0;
					msguser(nickserv,user,response);
				}
				return;
			}
			//snprintf(response,499,"Username %c%s%c is already registered for .",34,params,34,2,2);
			//response[499] = 0;
			return;
		}else{
			snprintf(response,499,"Username \"%s\" is \002free\002.",params);
			response[499] = 0;
			msguser(nickserv,user,response);
			return;
		}
	}
	if (strcasecmp(cmd,"identify") == 0) {
		trimleft(params);cutonfirstspace(params);
		if (strlen(params) <= 0) {
			msguser(nickserv,user,"Type \002/msg NickServ identify <password>\002 to login.");
			return;
		}
		const char* accname = weircd_user_GetLoginAccountName(user);
		if (accname != NULL) {
			snprintf(&response[0],499,"You are already identified as \002%s\002.",accname);
			response[499] = 0;
			msguser(nickserv,user,response);
			return;
		}
		if (services_userregistered(user) != 0) {
			snprintf(response,499,"Your nickname \002%s\002 is not registered.",user);
			response[499] = 0;
			msguser(nickserv,user,response);
			return;
		}
		MDString(params);
		char* p = services_upassword(user);
		if (p == NULL) {
			snprintf(response,499,"The server is currently experiencing a database problem. Please join %s for help!",weircd_GetHelpChan());
			response[499] = 0;
			msguser(nickserv,user,response);
			free(p);
			return;
		}else{
			if (strcasecmp(p,"") != 0) {
				if (strcasecmp(md5result,p) != 0) {//password is wrong
					if (weircd_services_NickservKill(weircd_user_GetIp(user)) == 0) {
						snprintf(response,499,"GLINE +*!*@%s 2m Too many failed login attempts! Banned for 2 minutes.",weircd_user_GetIp(user));
						response[499] = 0;
						weircd_fakeuser_Send(nickserv,response);
						free(p);
						return;
					}
					msguser(nickserv,user,"The password is wrong.");
					free(p);
					return;
				}else{
					weircd_services_NickservLogin(weircd_user_GetIp(user));
					//set registered flag
					weircd_services_SetUserLoginAccountName(user,user);
					msguser(nickserv,user,"*** You are now logged in (NickServ)");
					free(p);
					unexamineuser(user);
					return;
				}
			}
		}
	}
	if (strcasecmp(cmd,"changepass") == 0) {
		const char* accname = weircd_user_GetLoginAccountName(user);
		if (accname == NULL) {
			msguser(nickserv,user,"You are not logged in.");
			return;
		}else{
			trimleft(params);trimright(params);
			if (strlen(params) <= 2 || charpos(params,32) <= 0) {
				snprintf(response,499,"There are some parameters missing! Use %c/msg NickServ help changepass%c to check the correct syntax of this command",2,2);
				response[499] = 0;
				msguser(nickserv,user,response);
				return;
			}
			char willpw[50];
			strncpy(willpw,params,49);willpw[49] = 0;
			if (charpos(willpw,' ') > 0) {willpw[charpos(willpw,' ')] = 0;}
			trimright(willpw);
			cut(params,charpos(params,' ')+1);
			trimleft(params);
			if (charpos(params,' ') >= 0) {
				msguser(nickserv,user,"Too many parameters. Use \002/msg NickServ help changepass\002 to check the correct syntax of this command");
				return;
			}
			if (strlen(params) > 30) {
				msguser(nickserv,user,"The new password is too long (maximum 30 chars).");
				return;
			}
			if (strlen(params) < 8) {
				msguser(nickserv,user,"The new password is too short (minimum 8 chars).");
				return;
			}
			MDString(willpw);
			char* p = services_upassword(accname);
			if (p == NULL) {
				snprintf(response,499,"The server is currently experiencing a database problem. Please join %s for help!",weircd_GetHelpChan());
				response[499] = 0;
				msguser(nickserv,user,response);
				free(p);
				if (strlen(params) < 1 || strlen(willpw) < 1) {
					snprintf(response,499,"There are some parameters missing! Use %c/msg NickServ help register%c to check the correct syntax of this command",2,2);
					response[499] = 0;
					msguser(nickserv,user,response);
					return;
				}
				return;
			}else{
				if (strcasecmp(p,"") != 0) {
					if (strcasecmp(md5result,p) != 0) {
						if (weircd_services_NickservKill(weircd_user_GetIp(user)) == 0) {
							snprintf(response,499,"GLINE +*!*@%s 2m Too many failed password change attempts! Banned for 2 minutes.",weircd_user_GetIp(user));
							response[499] = 0;
							weircd_fakeuser_Send(nickserv,response);
							free(p);
							return;
						}
						msguser(nickserv,user,"The password is wrong.");
						free(p);
						return;
					}else{
						weircd_services_NickservLogin(weircd_user_GetIp(user));
						MDString(params);
						services_setnickpass(accname,md5result);
						msguser(nickserv,user,"The password has been changed.");
						free(p);
						return;
					}
				}
				return;
			}
		}
	}
	if (strcasecmp(cmd,"logout") == 0) {
		if (weircd_user_GetLoginAccountName(user) == NULL) {
			msguser(nickserv,user,"You are not logged in.");
			return;
		}else{
			weircd_services_SetUserLoginAccountName(user,NULL);
			msguser(nickserv,user,"*** You are now logged out and able to login to another account if you wish.");
			examineuser(user);
			return;
		}
	}
	if (strcasecmp(cmd,"register") == 0) {
		const char* acc = weircd_user_GetLoginAccountName(user);
		if (acc != NULL) {
			snprintf(response,499,"You are already logged in as %c%s%c.",2,acc,2);
			response[499] = 0;
			msguser(nickserv,user,response);
			return;
		}else{
			int timeframe = weircd_user_GetTimeSinceNickChange(user);
			if (timeframe < nicknameregisterwaittime) {
				snprintf(response,499,"Please wait %c%d seconds%c before you attempt to register your current nickname.",2,nicknameregisterwaittime-timeframe,2);
				response[499] = 0;
				msguser(nickserv,user,response);
				return;
			}else{
				if (strcasecmp(user,"guest") == 0 || strstw(user,"guest") == 0) {
					msguser(nickserv,user,"You cannot register this nickname.");
				}else{
					if (services_userregistered(user) == 0) {
						msguser(nickserv,user,"This nickname has already been registered.");
						return;
					}
					trimleft(params);
					if (strlen(params) <= 2 || charpos(params,32) <= 0) {
						snprintf(response,499,"There are some parameters missing! Use %c/msg NickServ help register%c to check the correct syntax of this command",2,2);
						response[499] = 0;
						msguser(nickserv,user,response);
						return;
					}
					char willpw[50];
					strncpy(willpw,params,49);willpw[49] = 0;
					cutonfirstspace(willpw);
					cut(params,charpos(params,32) + 1);
					cutonfirstspace(params);
					if (strlen(params) < 1 || strlen(willpw) < 1) {
						snprintf(response,499,"There are some parameters missing! Use %c/msg NickServ help register%c to check the correct syntax of this command",2,2);
						response[499] = 0;
						msguser(nickserv,user,response);
						return;
					}
					if (charpos(params,'@') <= 0) {
						snprintf(response,499,"The second parameter should be a %cvalid%c e-mail address - without a working e-mail address, your %caccount will be lost%c if you ever forget your password.",2,2,2,2);
						response[499] = 0;
						msguser(nickserv,user,response);
						return;
					}
					if (strlen(willpw) < 8 || strcasecmp(willpw,"password") == 0 || strcasecmp(willpw,"<password>") == 0 || strcasecmp(willpw,user) == 0 || strstw(willpw,user) == 0 || strendswith(willpw,user) == 0) {
						snprintf(response,499,"It is important that your password is very random and not too short (at least %c8 chars long%c). In case you can't remember it one day, you can ask for a new password in %s which will be send to your e-mail address, so don't fear to use a complicated password! %cThis password is too weak.%c",2,2,weircd_GetHelpChan(),2,2);
						response[499] = 0;
						msguser(nickserv,user,response);
						return;
					}
					MDString(willpw);
					if (services_registernick(user,md5result,params) != 0) {
						snprintf(response,499,"The %cregistration failed%c (Technical problem: database reports error). Please join %s for help.",2,2,weircd_GetHelpChan());
						response[499] = 0;
						msguser(nickserv,user,response);
						return;
					}else{
						weircd_services_SetUserLoginAccountName(user,user);
						//strlwr(userpointers[uid]->accountname);
						snprintf(response,499,"Your nickname %c%s%c is now registered.",2,user,2);
						response[499] = 0;
						msguser(nickserv,user,response);
						return;
					}
				}
			}
		}
	}
	msguser(nickserv,user,"Unknown command. Type \002/NickServ help\002 for help.");
}