//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void linkstcp_init() {
	int r = 0;
	while (r < MAXLINKS) {
		linkstcp[r] = NULL;
		r++;
	}
}
void linkstcp_recalculatenfds() {
	int r = 0;int k = 0;
	while (r < MAXPASSIVELINKS) {
		if (plinks[r] != NULL) {
			if (plinks[r]->socket >= 0) {
				k = plinks[r]->socket;
				if (k >= nfds) {nfds = k+1;}
			}
		}
		r++;
	}
	r = 0;
	while (r < MAXACTIVELINKS) {
		if (alinks[r] != NULL) {
			if (alinks[r]->socket >= 0) {
				k = alinks[r]->socket;
				if (k >= nfds) {nfds = k+1;}
			}
		}
		r++;
	}
}
void tcpplugindata_free(int id) {
	int r = 0;
	while (r < PLUGINDATA_MAXSTR) {
		if (linkstcp[id]->plugindata_str[r] != NULL) {
			free(linkstcp[id]->plugindata_str[r]);
			linkstcp[id]->plugindata_str[r] = NULL;
		}
		r++;
	}
}
void tcpdata_free(int id) {
	links_users_deltcp(id);
	tcpplugindata_free(id);
	if (linkstcp[id]->receivebuffer != NULL) {free(linkstcp[id]->receivebuffer);}
	if (linkstcp[id]->socketunselected == 0) {
		FD_CLR(linkstcp[id]->socket,&socketset);
		recalculatenfds();
		wantsend -= lt[id]->sendblocks;
	}
	close(linkstcp[id]->socket);
	linkstcp[id]->receivebuffer = NULL;
}
void linkstcp_closePassive(int id) {
	char tmp[500];
	//search tcp data blocks using this listener socket
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->type == LINKTYPE_PASSIVE && linkstcp[r]->id == id) {
				if (cTcp == r) {cTcp = -1;}
				if (linkstcp[r]->established == 1) {
					snprintf(tmp,499,"[LINKS] Closing down incoming connection from %s:%d",plinks[id]->ip,plinks[id]->port);
					tmp[499] = 0;
					IOnotice(tmp);
				}
				tcpdata_free(r);
				free(linkstcp[r]);
				linkstcp[r] = NULL;
				
				plinks[id]->socket = -1;
				
				recalculatenfds();
			}
		}
		r++;
	}
	if (delservcount > 0) {sendalllinks(links_users_delservers_get());}
}
void linkstcp_closeListener(int id) {
	char tmp[500];
	snprintf(tmp,499,"[LINKS] Closing down passive link on port %d",plinks[id]->port);
	tmp[499] = 0;
	IOnotice(tmp);	
	//first, dump all passive connections coming in at this listener
	int port = plinks[id]->port;
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->type == LINKTYPE_PASSIVE) {
				if (plinks[linkstcp[r]->id]->port == port) {
					int s = linkstcp[r]->id;
					linkstcp_closePassive(id);
					//free(plinks[s]->password); //NO!! we share the copy of our LINKTYPE_LISTENER parent!!
					//free(plinks[s]->protocol); //same goes for this!
					free(plinks[s]);
					plinks[s] = NULL;
				}
			}
		}
		r++;
	}
	//now search tcp data blocks of this listener and remove it aswell
	r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->type == LINKTYPE_LISTENER && linkstcp[r]->id == id) {
				linkstcp_closePassive(id);//works for this listener aswell
				
				plinks[id]->socket = -1;
			}
		}
		r++;
	}
}
void linkstcp_closeActive(int id, int silent) {
	char tmp[500];
	//search tcp data blocks using this listener socket
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->type == LINKTYPE_ACTIVE && linkstcp[r]->id == id) {
				if (cTcp == r) {cTcp = -1;}
				alinks[id]->socket = -1;
				tcpdata_free(r);
				free(linkstcp[r]);
				linkstcp[r] = NULL;
				if (silent <= 0) {
					snprintf(tmp,499,"[LINKS] Closing down active link to %s:%d",alinks[id]->target,alinks[id]->port);
					tmp[499] = 0;
					IOnotice(tmp);
				}
				recalculatenfds();
			}
		}
		r++;
	}
	if (delservcount > 0) {sendalllinks(links_users_delservers_get());}
}
int linkstcp_ensurebuffer(int tcp) {
	if (linkstcp[tcp]->receivebuffer == NULL) {
		linkstcp[tcp]->receivebuffer = malloc(linkstcp[tcp]->linesize*2);
		if (linkstcp[tcp]->receivebuffer == NULL) {cTcp = -1;return -1;}
		strcpy(linkstcp[tcp]->receivebuffer,"");
	}
	return 0;
}
int linkstcp_getPassiveTcp(int id) {
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->type == LINKTYPE_PASSIVE && linkstcp[r]->id == id) {
				return r;
			}
		}
		r++;
	}
	return -1;
}
int linkstcp_getActiveTcp(int id) {
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->type == LINKTYPE_ACTIVE && linkstcp[r]->id == id) {
				return r;
			}
		}
		r++;
	}
	return -1;
}
int linkstcp_openPassive(int id) {
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] == NULL) {
			linkstcp[r] = malloc(sizeof(struct weircd_linktcpdata));
			if (linkstcp[r] == NULL) {return -1;}
			memset(linkstcp[r],0,sizeof(struct weircd_linktcpdata));
			linkstcp[r]->type = LINKTYPE_PASSIVE;
			linkstcp[r]->socket = -1;
			linkstcp[r]->id = id;
			linkstcp[r]->lastping = ts();
			lt[r]->lastreceive = ts();
			//enable our receive buffers
			linkwrapper_environment(r);
			enableLink(plinks[id]->protocol);
			if (linkstcp_ensurebuffer(r) < 0) {
				wlinks_msg("CRITICAL ERROR: Linking module %s fails to setup receive buffer!",plinks[id]->protocol);
				free(linkstcp[r]);
				linkstcp[r] = NULL;
				return -1;
			}
			//ok we are done
			return r;
		}
		r++;
	}
	return -1;
}
int linkstcp_openListener(int id) {
	struct sockaddr_in bindaddress;
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] == NULL) {
			linkstcp[r] = malloc(sizeof(struct weircd_linktcpdata));
			if (linkstcp[r] == NULL) {return -1;}
			memset(linkstcp[r],0,sizeof(struct weircd_linktcpdata));
			linkstcp[r]->type = LINKTYPE_LISTENER;
			linkstcp[r]->socket = -1;
			
			linkstcp[r]->socket = socket(AF_INET, SOCK_STREAM, 0);
			if (linkstcp[r]->socket < 0) {tcpdata_free(r);free(linkstcp[r]);linkstcp[r] = NULL;return -1;}
			memset(&bindaddress, 0, sizeof(struct sockaddr_in));
			bindaddress.sin_port = htons (plinks[id]->port);
			bindaddress.sin_family = AF_INET;
			if (strcasecmp(currentoptions.bindip,"any") != 0) {
#ifdef WIN
				bindaddress.sin_addr.s_addr = inet_addr(currentoptions.bindip);
				if (bindaddress.sin_addr.s_addr == INADDR_NONE || bindaddress.sin_addr.s_addr == INADDR_ANY) {
#endif
#ifndef WIN
				if (!inet_aton(currentoptions.bindip, &bindaddress.sin_addr)) {
#endif
					printf("ADDRESS FAIL\n");free(linkstcp[r]);linkstcp[r] = NULL;return -1;
				}
			}else{
				bindaddress.sin_addr.s_addr = INADDR_ANY;
				bindaddress.sin_family = AF_INET;
			}
			
			if (bind(linkstcp[r]->socket,(struct sockaddr *) &bindaddress,sizeof (bindaddress)) != 0) {
				printf("BINDFAIL\n");tcpdata_free(r);free(linkstcp[r]);linkstcp[r] = NULL;return -1;
			}
			listen(linkstcp[r]->socket, plinks[id]->port);
			setSocketNonblocking(linkstcp[r]->socket);
			FD_SET(linkstcp[r]->socket,&socketset);
			plinks[id]->socket = linkstcp[r]->socket;
			linkstcp[r]->id = id;
			linkstcp[r]->lastping = ts();
			linkstcp_recalculatenfds();
			return 0;
		}
		r++;
	}
	return -1;
}
int linkstcp_startActive(int id) {
	struct sockaddr_in tgaddress;
	struct hostent *he = NULL;
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] == NULL) {
			linkstcp[r] = malloc(sizeof(struct weircd_linktcpdata));
			if (linkstcp[r] == NULL) {return -1;}
			memset(linkstcp[r],0,sizeof(struct weircd_linktcpdata));
			linkstcp[r]->type = LINKTYPE_ACTIVE;
			//linkstcp[r]->established = 0;
			linkstcp[r]->socket = socket(AF_INET, SOCK_STREAM, 0);
			if (linkstcp[r]->socket < 0) {free(linkstcp[r]);linkstcp[r] = NULL;return -1;}
			memset(&tgaddress, 0, sizeof(struct sockaddr_in));
			//resolve our target:
			if(!(he = gethostbyname(alinks[id]->target))){
				if((tgaddress.sin_addr.s_addr = inet_addr(alinks[id]->target)) == INADDR_NONE) {
					//resolving failed, and it's no ip
					free(linkstcp[r]);linkstcp[r] = NULL;return -1;
				}else{
					//it was already an ip
				}
			}else{
				//resolving was successful
				memcpy((struct in_addr *) &tgaddress.sin_addr, he->h_addr_list[0], he->h_length);
			}
			tgaddress.sin_family = AF_INET;
			tgaddress.sin_port = htons (alinks[id]->port);
			setSocketNonblocking(linkstcp[r]->socket);
			if (connect(linkstcp[r]->socket,(struct sockaddr *) &tgaddress, sizeof(tgaddress)) < 0) {
#ifdef WIN
				errno = WSAGetLastError();
				if (errno != WSAEWOULDBLOCK) {
					free(linkstcp[r]);linkstcp[r] = NULL;return -1;
				}else{
					linkstcp[r]->connecting = 1;
				}
#endif
#ifndef WIN
				if (errno != EINPROGRESS) {
					free(linkstcp[r]);linkstcp[r] = NULL;return -1;
				}else{
					linkstcp[r]->connecting = 1;
				}
#endif
			}
			FD_SET(linkstcp[r]->socket,&socketset);
			alinks[id]->socket = linkstcp[r]->socket;
			alinks[id]->tcp = r;
			linkstcp[r]->id = id;
			linkstcp[r]->lastping = ts();
			linkstcp[r]->connecttime = ts();
			lt[r]->lastreceive = ts();
			linkstcp_recalculatenfds();
			if (linkstcp[r]->connecting == 0) {
				//already connected? huh
				activelinks_processconnect(id);
			}
			//enable our receive buffers
			linkwrapper_environment(r);
			currentLinkType = LINKTYPE_PASSIVE;
			enableLink(alinks[id]->protocol);
			return 0;
		}
		r++;
	}
	return -1;
}
void linkstcp_doReceive(int tcp) {
	if (linkstcp[tcp] == NULL) {return;}
	int id = linkstcp[tcp]->id;
	int passive;
	if (linkstcp[tcp]->type == LINKTYPE_PASSIVE) {
		passive = 1;
	}else{
		if (linkstcp[tcp]->connecting == 1) {return;}
		passive = 0;
	}
	char* buf = linkstcp[tcp]->receivebuffer;
	char lclbuffa[4000];
	int j = linkstcp[tcp]->linesize*2;
	if (j > 4000) {j = 4000;}
	int z;
	if (linkstcp[tcp]->socketunselected == 1) {return;}
	if (!FD_ISSET(linkstcp[tcp]->socket,cpy)) {return;}
	if (strlen(buf) < j - 1) {
		int k = strlen(buf);
		errno = 0;
		z = recv(linkstcp[tcp]->socket,lclbuffa,j - (k+1),0);
		if (z > 0) {
			lclbuffa[z] = 0;
			strcat(buf,lclbuffa);
			k = k+z;
			z = 0;
			while (z < k) {
				if (buf[z] == 0) {buf[z] = 32;}
				z += 1;
			}
			z = 0;
			while (z < k-1) {
				if (buf[z] == '\r') {
					buf[z] = '\n';
					if (buf[z+1] == '\n') {
						buf[z+1] = 32;
					}
				}
				z += 1;
			}
			buf[k] = 0;
			while (charpos(buf,'\n') >= 0) {
				strcpy(lclbuffa,buf);
				lclbuffa[charpos(lclbuffa,'\n')] = 0;
				cut(buf,charpos(buf,'\n')+1);
				if (onlyspaces(lclbuffa) != 0) {
					trimleft(lclbuffa);
					linkstcp[tcp]->lastreceive = ts();
					wlinks_cycleChannels_reset();
					wlinks_cycleUsers_reset();
					#ifdef ACTIVATEDEBUG
						if (strstw(lclbuffa,"ping ") == 0 && strstw(lclbuffa,"pong ") == 0) {
							printf("rcLINK[%d] %s\n",tcp,lclbuffa);
						}
					#endif
					if (passive == 1) {
						receiveOnLink(plinks[id]->protocol, lclbuffa);
					}else{
						receiveOnLink(alinks[id]->protocol, lclbuffa);
					}
				}
				if (linkstcp[tcp] == NULL) {return;}
				if (linkstcp[tcp]->needquit == 1) {return;}
			}
			if (strlen(buf) >= linkstcp[tcp]->linesize) {
			//one line is too long
				strcpy(buf,"");
			}
			return;
		}else{
#ifdef WIN
			int err = WSAGetLastError();
			if ((err != WSAEWOULDBLOCK && err != WSAEINTR && err != WSAENOBUFS) || z == 0) {
#endif
#ifndef WIN
			if ((errno != EWOULDBLOCK && errno != EINTR && errno != EAGAIN && errno != ENOBUFS) || z == 0) {
#endif
				if (linkstcp[tcp]->socketunselected == 0) {
					linkstcp[tcp]->socketunselected = 1;
					FD_CLR(linkstcp[tcp]->socket,&socketset);
					recalculatenfds();
					wantsend -= lt[tcp]->sendblocks;
				}
				linkstcp[tcp]->needquit = 1;
			}
		}
	}else{
		strcpy(buf,"");
	}
}
char* prot(int id) {
	if (lt[id]->type == LINKTYPE_ACTIVE) {
		return alinks[lt[id]->id]->protocol;
	}else{
		return plinks[lt[id]->id]->protocol;
	}
}
void linktcp_checktimeout() {
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->linesize > 5 && linkstcp[r]->connecting == 0 && linkstcp[r]->type != LINKTYPE_LISTENER) {
				if (linkstcp[r]->lastping == 0) {linkstcp[r]->lastping = ts();}
				if (linkstcp[r]->lastping + 10 < ts()) {
					if (linkstcp[r]->waitingforpong == 0) {
						linkwrapper_environment(r);
						sendOnLink(prot(r),"PING :bla");
						linkstcp[r]->waitingforpong = ts();
					}
				}
				if (linkstcp[r]->lastreceive + 15 < ts()) {
					if (linkstcp[r]->type == LINKTYPE_ACTIVE) {
						linkstcp_closeActive(linkstcp[r]->id,0);
					}else{
						linkstcp_closePassive(linkstcp[r]->id);
					}
				}
			}
		}
		r++;
	}
}
void linktcp_closeforshutdown() {
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			close(linkstcp[r]->socket);
		}
		r++;
	}
}

