//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>

//<--- OS DEFINITIONS - DO NOT CHANGE --->

#ifndef WEIRD_OS_H
#define WEIRD_OS_H

#undef WIN
#undef osname

#ifdef __linux__
#define SAFEUNIX
#define osname "linux"
#endif

#if defined(_WIN32) || defined(_WIN64) || defined(WIN32) || defined(WIN64) || defined(__WIN32__) || defined(WINDOWS)
#define WIN
#undef SAFEUNIX
#define osname "win"
#endif

#ifdef __APPLE__
#undef SAFEUNIX
#define MAC
#define osname "mac"
#endif

#ifdef __sun
#undef SAFEUNIX
#define osname "solaris"
#endif

#if defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__)
#define SAFEUNIX
#define osname "bsd"
#endif

#if !defined(osname)
#undef SAFEUNIX
#warning "<<<< YOUR OPERATING SYSTEM is probably NOT SUPPORTED >>>>"
#endif

#ifdef WIN
//needed for mingw to get us getnameinfo() and other XP only functions
#define VER_PLATFORM_WIN32_NT
//#define _WIN32_WINNT
#endif

#endif